#!/usr/bin/env python
#
# Duo, A crazy eights game.
# Copyright (C) 2003-2008 The Duo developers.
#
# This file is part of Duo.
#
# Duo is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# Make locale for Duo.
# Based on make locale for Batch Renamer (batchrenamer.sourceforge.net).
#

import os
import sys

#
# make sure that the following four tools can be found by this script.
#
# Please see http://www.gnu.org/software/gettext/ for more information on the
# GNU gettext package.
#

POT_FILE = os.path.join('po', 'duo.pot')

msgfmt = 'msgfmt -o %s %s'
xgettext = 'xgettext --language=Python --keyword=_ --output=' + POT_FILE + ' duo/ui/tk.py'
msgmerge = 'msgmerge %s %s -o %s'
msgcheck = 'msgfmt --statistics %s'


option = ''
if ((len(sys.argv) > 1) and (sys.argv[1] == 'm')):
    option = 'M'
elif ((len(sys.argv) > 1) and (sys.argv[1] == 'c')):
    option = 'C'

# If Merge, extract new strings from program.
if (option == 'M'):
    os.system(xgettext)

# Proceed to translations...
po_files = os.listdir('po')
for po in po_files:
    if po.endswith('.po'):
        lang = po[:-3]
        po_file = os.path.join('po', po)
        mo_path = os.path.join('locale', lang, 'LC_MESSAGES')
        mo_file = os.path.join(mo_path, 'duo.mo')

        print '\n* Working on %s...' % lang

        # MERGE
        if (option == 'M'):
            print 'Merging...'
            os.system(msgmerge % (os.path.join('po', po), POT_FILE, po_file))

        # BUILD
        if option != 'C':
            print 'Compiling to %s...' % mo_file
            try:
                os.remove(mo_file)
            except OSError:
                pass
            try:
                os.makedirs(mo_path)
            except OSError:
                pass
            os.system(msgfmt % (mo_file, po_file))

        # CHECK
        os.system(msgcheck % po_file)

# TODO: WTF is this file ?
try:
    os.remove('messages.mo')
except OSError:
    pass
